//------------------------------------------------------------------
#property copyright "mladen"
#property link      "mladenfx@gmail.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  LimeGreen
#property indicator_color2  DarkOrange
#property indicator_color3  DarkOrange
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_minimum  -5
#property indicator_maximum 105
#property indicator_level1  80
#property indicator_level2  80

//
//
//
//
//

extern int STCPeriod = 70;
extern int RsiPeriod = 25;
extern int RsiPrice  = PRICE_CLOSE;

//
//
//
//
//

double stcBuffer[];
double stcBufferDa[];
double stcBufferDb[];
double valBuffer[];
double fastKBuffer[];
double fastDBuffer[];
double fastKKBuffer[];
double slope[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,stcBuffer);
   SetIndexBuffer(1,stcBufferDa);
   SetIndexBuffer(2,stcBufferDb);
   SetIndexBuffer(3,valBuffer);
   SetIndexBuffer(4,fastKBuffer);
   SetIndexBuffer(5,fastDBuffer);
   SetIndexBuffer(6,fastKKBuffer);
   SetIndexBuffer(7,slope);
   IndicatorShortName("Schaff Trend Cycle of DeMarker ("+STCPeriod+","+RsiPeriod+")");
   return(0);
}

int deinit()
{
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
      if (slope[limit] == -1) ClearPoint(limit,stcBufferDa,stcBufferDb);
      for(int i = limit; i >= 0; i--)
      {
         valBuffer[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);

         //
         //
         //
         //
         //
         
         double lowVal  = minValue(valBuffer,i);
         double highVal = maxValue(valBuffer,i)-lowVal;
            if (lowVal > 0)
                  fastKBuffer[i] = 100*((valBuffer[i]-lowVal)/highVal);
            else  fastKBuffer[i] = fastKBuffer[i+1];
                  fastDBuffer[i] = fastDBuffer[i+1]+0.5*(fastKBuffer[i]-fastDBuffer[i+1]);
               
         //
         //
         //
         //
         //
                     
         double lowStoch  = minValue(fastDBuffer,i);
         double highStoch = maxValue(fastDBuffer,i)-lowStoch;
            if (highStoch > 0)
                  fastKKBuffer[i] = 100*((fastDBuffer[i]-lowStoch)/highStoch);
            else  fastKKBuffer[i] = fastKKBuffer[i+1];
                  stcBuffer[i]    = stcBuffer[i+1]+0.5*(fastKKBuffer[i]-stcBuffer[i+1]);
                  stcBufferDa[i]  = EMPTY_VALUE;
                  stcBufferDb[i]  = EMPTY_VALUE;
                  slope[i]        = slope[i+1];
                     if (stcBuffer[i]>stcBuffer[i+1]) slope[i] =  1;
                     if (stcBuffer[i]<stcBuffer[i+1]) slope[i] = -1;
                     if (slope[i] == -1) PlotPoint(i,stcBufferDa,stcBufferDb,stcBuffer);
      }   
      return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double minValue(double& array[],int shift)
{
   double minValue = array[shift];
            for (int i=1; i<STCPeriod; i++) minValue = MathMin(minValue,array[shift+i]);
   return(minValue);
}
double maxValue(double& array[],int shift)
{
   double maxValue = array[shift];
            for (int i=1; i<STCPeriod; i++) maxValue = MathMax(maxValue,array[shift+i]);
   return(maxValue);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void ClearPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
   {
      if (first[i+2] == EMPTY_VALUE) 
      {
          first[i]    = from[i];
          first[i+1]  = from[i+1];
          second[i]   = EMPTY_VALUE;
      }
      else
      {
          second[i]   = from[i];
          second[i+1] = from[i+1];
          first[i]    = EMPTY_VALUE;
      }
   }
   else
   {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}